--========================================================--
--                Enhance Battlefield Minimap             --
--                                                        --
-- Author      :  kurapica125@outlook.com                 --
-- Create Date :  2017/03/04                              --
--========================================================--

--========================================================--
Scorpio            "EnhanceBattlefieldMinimap"       "1.0.1"
--========================================================--

MOVE_MINIMAP_THREADIDX  = 0
ORIGIN_PLAYER_SIZE      = 32

max                     = math.max
min                     = math.min
abs                     = math.abs

BattlefieldMinimapBlob  = false
BattlefieldMinimapPOI   = false

----------------------------------------------
-------------- Addon Event Handler -----------
----------------------------------------------
function OnLoad(self)
    _SVDB = SVManager.SVCharManager("EnhanceBattlefieldMinimap_DB")

    _SVDB:SetDefault {
        -- Display Status
        MaskScale       = 1.0,
        MinimapScale    = 1.0,
        VerticalScroll  = 0,
        HorizontalScroll= 0,

        -- Settings
        HideInCombat    = true,
        LockOnPlayer    = true,
        ShowQuestPOI    = true,
        ShowWorldQuest  = true,
        ShowLandmark    = true,
    }
end

__Thread__()
function OnEnable(self)
    if not IsAddOnLoaded("Blizzard_BattlefieldMinimap") then
        while Event("ADDON_LOADED") ~= "Blizzard_BattlefieldMinimap" do end
    end

    BattlefieldMinimapBackground:Hide()
    BattlefieldMinimapCloseButton:Hide()
    BattlefieldMinimapCorner:Hide()

    if not WorldMapFrame:IsVisible() then
        WorldMapTooltip:SetParent(UIParent)
        WorldMapTooltip:SetFrameLevel(1000)
    end

    BattlefieldMinimapTab:SetFrameStrata("HIGH")
    BattlefieldMinimapTabLeft:SetTexture(nil)
    BattlefieldMinimapTabMiddle:SetTexture(nil)
    BattlefieldMinimapTabRight:SetTexture(nil)
    BattlefieldMinimapTabText:Hide()

    BattlefieldMinimap:EnableMouseWheel(true)
    BattlefieldMinimap:SetMovable(true)

    BattlefieldMinimapScroll = CreateFrame("ScrollFrame", "BattlefieldMinimapScroll", UIParent)

    for i = 1, BattlefieldMinimap:GetNumPoints() do
        BattlefieldMinimapScroll:SetPoint(BattlefieldMinimap:GetPoint(i))
    end

    ORIGIN_WIDTH, ORIGIN_HEIGHT = BattlefieldMinimap:GetSize()

    BattlefieldMinimapScroll:SetSize(ORIGIN_WIDTH * _SVDB.MaskScale, ORIGIN_HEIGHT * _SVDB.MaskScale)
    BattlefieldMinimapScroll:SetScrollChild(BattlefieldMinimap)

    BattlefieldMinimap:ClearAllPoints()
    BattlefieldMinimap:SetPoint("TOPLEFT", BattlefieldMinimapScroll, "TOPLEFT")
    BattlefieldMinimap:SetScale(_SVDB.MinimapScale)

    BattlefieldMinimapScroll:UpdateScrollChildRect()
    BattlefieldMinimapScroll:SetVerticalScroll(_SVDB.VerticalScroll)
    BattlefieldMinimapScroll:SetHorizontalScroll(_SVDB.HorizontalScroll)

    UpdateHitRectInsets()

    BattlefieldMinimap:HookScript("OnMouseWheel", OnMouseWheel)
    BattlefieldMinimap:HookScript("OnMouseDown", OnMouseDown)
    BattlefieldMinimap:HookScript("OnMouseUp", OnMouseUp)
    BattlefieldMinimap:HookScript("OnShow", OnShow)
    BattlefieldMinimap:HookScript("OnEnter", OnEnter)
    BattlefieldMinimap:HookScript("OnLeave", OnLeave)
    BattlefieldMinimapTab:HookScript("OnEnter", TabOnEnter)
    BattlefieldMinimapTab:HookScript("OnLeave", TabOnLeave)

    WorldMapFrame:HookScript("OnShow", WorldMapOnShow)
    WorldMapFrame:HookScript("OnHide", WorldMapOnHide)

    ORIGIN_SETUNIT = BattlefieldMinimapUnitPositionFrame.AddUnit
    BattlefieldMinimapUnitPositionFrame.AddUnit = BattlefieldMinimapUnitPositionFrame_AddUnit
    --_M:SecureHook(BattlefieldMinimapUnitPositionFrame, "AddUnit", BattlefieldMinimapUnitPositionFrame_AddUnit)

    if _SVDB.LockOnPlayer and BattlefieldMinimap:IsVisible() then
        LockOnPlayer()
    end

    -- Quest POI
    BattlefieldMinimapBlob = CreateFrame("QuestPOIFrame", "BattlefieldMinimapBlobFrame", BattlefieldMinimap)
    BattlefieldMinimapBlob:SetAllPoints()
    WorldMapBlobFrame_OnLoad(BattlefieldMinimapBlob)
    BattlefieldMinimapBlob:SetScale(1 / BattlefieldMinimap:GetScale())

    -- World Map POI
    BattlefieldMinimapPOI = CreateFrame("Frame", "BattlefieldMinimapPOIFrame", BattlefieldMinimap)
    BattlefieldMinimapPOI:SetAllPoints()
    QuestPOI_Initialize(BattlefieldMinimapPOI, WorldMapPOIButton_Init)
    BattlefieldMinimapPOI:SetScale(1 / BattlefieldMinimap:GetScale())

    POIArray       = List()
    GraveyardArray = List()
    TaskPOIArray   = List()

    FireSystemEvent("EBFM_INITED")

    RefreshLandmarks()
    QuestMapFrame_UpdateAll()
end

function OnQuit(self)
    -- Save settings
    _SVDB.MaskScale         = BattlefieldMinimapScroll:GetWidth() / ORIGIN_WIDTH
    _SVDB.MinimapScale      = BattlefieldMinimap:GetScale()
    _SVDB.HorizontalScroll  = BattlefieldMinimapScroll:GetHorizontalScroll()
    _SVDB.VerticalScroll    = BattlefieldMinimapScroll:GetVerticalScroll()
end

__SlashCmd__("ebfm", "nocombat", _Locale["on/off - hide during combat"])
function ToggleNoCombat(opt)
    if opt == "on" then
        _SVDB.HideInCombat = true
    elseif opt == "off" then
        _SVDB.HideInCombat = false
    else
        return false
    end
end

__SlashCmd__("ebfm", "lockplayer", _Locale["on/off - lock on the player"])
function ToggleLockPlayer(opt)
    if opt == "on" then
        if not _SVDB.LockOnPlayer then
            _SVDB.LockOnPlayer = true
            if BattlefieldMinimap:IsVisible() and not BattlefieldMinimapScroll:IsMouseOver() then
                return LockOnPlayer()
            end
        end
    elseif opt == "off" then
        _SVDB.LockOnPlayer = false
    else
        return false
    end
end

__SlashCmd__("ebfm", "quest", _Locale["on/off - show quest marks"])
function ToggleQuest(opt)
    if opt == "on" then
        _SVDB.ShowQuestPOI = true
        DrawQuestPOI()
    elseif opt == "off" then
        _SVDB.ShowQuestPOI = false
        DrawQuestPOI()
    else
        return false
    end
end

__SlashCmd__("ebfm", "worldquest", _Locale["on/off - show world quest marks"])
function ToggleWorldQuest(opt)
    if opt == "on" then
        if not _SVDB.ShowWorldQuest then
            _SVDB.ShowWorldQuest = true
            DrawQuestBonusObjectives()
        end
    elseif opt == "off" then
        if _SVDB.ShowWorldQuest then
            _SVDB.ShowWorldQuest = false
            TaskPOIArray:Each("x=>x:Hide()")
        end
    else
        return false
    end
end

__SlashCmd__("ebfm", "landmark", _Locale["on/off - show land marks"])
function ToggleLandmark(opt)
    if opt == "on" then
        if not _SVDB.ShowLandmark then
            _SVDB.ShowLandmark = true
            DrawLandmarks()
        end
    elseif opt == "off" then
        if _SVDB.ShowLandmark then
            _SVDB.ShowLandmark = false
            POIArray:Each("x=>x:Hide()")
            GraveyardArray:Each("x=>x:Hide()")
        end
    else
        return false
    end
end

__AddonSecureHook__ "Blizzard_BattlefieldMinimap"
function BattlefieldMinimapTabDropDown_ShowOpacity()
    OpacityFrame:ClearAllPoints()
    OpacityFrame:SetPoint("TOPRIGHT", BattlefieldMinimapScroll, "TOPLEFT", 0, 7)
end

__SystemEvent__() __Thread__()
function PLAYER_REGEN_ENABLED()
    if not BattlefieldMinimapScroll:IsVisible() then
        BattlefieldMinimapScroll:SetAlpha(0)
        BattlefieldMinimapScroll:Show()

        local st = GetTime()
        while BattlefieldMinimapScroll:IsVisible() do
            local alpha = (GetTime() - st) / 3.0
            if alpha < 1 then
                BattlefieldMinimapScroll:SetAlpha(alpha)
            else
                BattlefieldMinimapScroll:SetAlpha(1)
                break
            end

            Next()
        end
    end
end

__SystemEvent__()
function PLAYER_REGEN_DISABLED()
    if _SVDB.HideInCombat then
        BattlefieldMinimapScroll:Hide()
    end
end

__SystemEvent__ "WORLD_MAP_UPDATE"
    "REQUEST_CEMETERY_LIST_RESPONSE"
    "RESEARCH_ARTIFACT_DIG_SITE_UPDATED"
    "SUPER_TRACKED_QUEST_CHANGED"
    "QUEST_LOG_UPDATE"
    "WORLD_QUEST_COMPLETED_BY_SPELL"
    "MINIMAP_UPDATE_TRACKING"
function RefreshLandmarks()
    if BattlefieldMinimapBlob then
        DrawQuestBlobs()
    end
    if BattlefieldMinimapPOI then
        DrawLandmarks()
        DrawQuestBonusObjectives()
        DrawQuestPOI()
    end
    FireSystemEvent("EBFM_REFRESH")
end

__SecureHook__ "QuestMapFrame_UpdateAll"
function UpdateAllQuest()
    if WorldMapFrame:IsShown() then return end

    local poiTable = { }
    if ( QuestMapUpdateAllQuests() > 0 and GetCVarBool("questPOI") ) then
        GetQuestPOIs(poiTable)
    end
    DrawQuestPOI(poiTable)
end

__SecureHook__ "WorldMapPOIFrame_Update"
function DrawQuestPOI(poiTable)
    if not BattlefieldMinimapPOI then return end

    QuestPOI_ResetUsage(BattlefieldMinimapPOI)

    if not _SVDB.ShowQuestPOI then
        QuestPOI_HideUnusedButtons(BattlefieldMinimapPOI)
        return
    end

    if poiTable  then
        NEW_POITABLE = poiTable
    else
        poiTable = NEW_POITABLE
    end

    if not poiTable then return end

    local detailQuestID = QuestMapFrame_GetDetailQuestID()
    local poiButton
    for index, questID in pairs(poiTable) do
        if ( not detailQuestID or questID == detailQuestID ) then
            local _, posX, posY = QuestPOIGetIconInfo(questID)
            if ( posX and posY ) then
                if ( IsQuestComplete(questID) ) then
                    poiButton = QuestPOI_GetButton(BattlefieldMinimapPOI, questID, "map", nil)
                else
                    -- if a quest is being viewed there is only going to be one POI and it's going to have number 1
                    poiButton = QuestPOI_GetButton(BattlefieldMinimapPOI, questID, "numeric", (detailQuestID and 1) or index)
                end
                WorldMapPOIFrame_AnchorPOI(poiButton, posX, posY, WORLD_MAP_POI_FRAME_LEVEL_OFFSETS.TRACKED_QUEST)
            end
        end
    end
    WorldMapPOIFrame_SelectPOI(GetSuperTrackedQuestID())
    QuestPOI_HideUnusedButtons(BattlefieldMinimapPOI)
end

----------------------------------------------
----------------- Addon Helpers --------------
----------------------------------------------
function OnShow(self)
    if _SVDB.LockOnPlayer and not BattlefieldMinimapScroll:IsMouseOver() then
        return LockOnPlayer()
    end
    RefreshLandmarks()
end

__Thread__()
function OnEnter(self)
    TabOnEnter()
    UpdateOpacity(0)

    DISPLAY_BLOB_TIP = false

    while BattlefieldMinimapScroll:IsMouseOver() do
        local ox, oy = BattlefieldMinimapScroll:GetHorizontalScroll(), BattlefieldMinimapScroll:GetVerticalScroll()
        local cx, cy = GetCursorPosition()
        local rscale = (WorldMapFrame_InWindowedMode() and UIParent or WorldMapFrame):GetScale()
        local scale = BattlefieldMinimap:GetScale()

        cx = (cx / rscale - BattlefieldMinimapScroll:GetLeft()) / scale + ox
        cy = (BattlefieldMinimapScroll:GetTop() - cy / rscale) / scale + oy

        cx = cx / BattlefieldMinimap:GetWidth()
        cy = cy / BattlefieldMinimap:GetHeight()

        if not WorldMapTooltip:IsShown() or DISPLAY_BLOB_TIP then
            -- Check the Blob
            local qid, numObj = BattlefieldMinimapBlob:UpdateMouseOverTooltip(cx, cy)

            if numObj then
                DISPLAY_BLOB_TIP = true
                WorldMapQuestPOI_SetTooltip(nil, qid, numObj)
            else
                DISPLAY_BLOB_TIP = false
                WorldMapTooltip:Hide()
            end
        end

        Next()
    end
end

__Thread__()
function OnLeave(self)
    if _SVDB.LockOnPlayer then LockOnPlayer() end
    TabOnLeave()

    local tar = BattlefieldMinimapOptions.opacity or 0
    if tar == 0 then return end

    local st = GetTime()

    while not BattlefieldMinimapScroll:IsMouseOver() do
        local opacity = (GetTime() - st) / 2.0 * tar

        if opacity < tar then
            UpdateOpacity(opacity)
        else
            UpdateOpacity(tar)
            break
        end

        Next()
    end
end

__Thread__()
function OnMouseDown(self)
    MOVE_MINIMAP_THREADIDX = MOVE_MINIMAP_THREADIDX + 1
    local task = MOVE_MINIMAP_THREADIDX

    local scale  = BattlefieldMinimap:GetScale()
    local rx, ry = max(BattlefieldMinimap:GetWidth() - BattlefieldMinimapScroll:GetWidth() / scale, 0), max(BattlefieldMinimap:GetHeight() - BattlefieldMinimapScroll:GetHeight() / scale, 0)
    local sx, sy = BattlefieldMinimapScroll:GetHorizontalScroll(), BattlefieldMinimapScroll:GetVerticalScroll()
    local cx, cy = GetCursorPosition()

    while task == MOVE_MINIMAP_THREADIDX do
        Next()

        local x, y = GetCursorPosition()

        x = max(0, min(sx - (x - cx) / scale, rx))
        y = max(0, min(sy + (y - cy) / scale, ry))

        BattlefieldMinimapScroll:SetHorizontalScroll(x)
        BattlefieldMinimapScroll:SetVerticalScroll(y)

        UpdateHitRectInsets()
    end
end

function OnMouseUp(self)
    -- Stop the OnMouseDown thread
    MOVE_MINIMAP_THREADIDX = MOVE_MINIMAP_THREADIDX + 1
end

function OnMouseWheel(self, d)
    if not IsAltKeyDown() then
        -- Scale the minimap
        local ox, oy = BattlefieldMinimapScroll:GetHorizontalScroll(), BattlefieldMinimapScroll:GetVerticalScroll()
        local cx, cy = GetCursorPosition()
        local rscale = (WorldMapFrame_InWindowedMode() and UIParent or WorldMapFrame):GetScale()

        cx = cx / rscale - BattlefieldMinimapScroll:GetLeft()
        cy = BattlefieldMinimapScroll:GetTop() - cy / rscale

        local oscale = self:GetScale()
        local nscale = max(0.1, oscale + d * 0.15)
        local framex = cx / oscale + ox
        local framey = cy / oscale + oy

        self:SetScale(nscale)

        BattlefieldMinimapScroll:SetHorizontalScroll(framex - cx / nscale)
        BattlefieldMinimapScroll:SetVerticalScroll(framey - cy / nscale)
    else
        -- Scale the window
        _SVDB.MaskScale = max(0.3, _SVDB.MaskScale + d * 0.05)
        BattlefieldMinimapScroll:SetSize(ORIGIN_WIDTH * _SVDB.MaskScale, ORIGIN_HEIGHT * _SVDB.MaskScale)
    end

    -- Re-check the scroll ranges
    BattlefieldMinimapScroll:UpdateScrollChildRect()

    local scale  = BattlefieldMinimap:GetScale()
    local rx, ry = max(BattlefieldMinimap:GetWidth() - BattlefieldMinimapScroll:GetWidth() / scale, 0), max(BattlefieldMinimap:GetHeight() - BattlefieldMinimapScroll:GetHeight() / scale, 0)

    if rx <= 0 or ry <= 0 then
        BattlefieldMinimap:SetScale(BattlefieldMinimapScroll:GetWidth() / BattlefieldMinimap:GetWidth())
        BattlefieldMinimapScroll:UpdateScrollChildRect()
        BattlefieldMinimapScroll:SetHorizontalScroll(0)
        BattlefieldMinimapScroll:SetVerticalScroll(0)
    else
        local x, y = BattlefieldMinimapScroll:GetHorizontalScroll(), BattlefieldMinimapScroll:GetVerticalScroll()
        x = max(0, min(x, rx))
        y = max(0, min(y, ry))

        BattlefieldMinimapScroll:SetHorizontalScroll(x)
        BattlefieldMinimapScroll:SetVerticalScroll(y)
    end

    BattlefieldMinimapPOI:SetScale(1 / BattlefieldMinimap:GetScale())
    BattlefieldMinimapBlob:SetScale(1 / BattlefieldMinimap:GetScale())

    UpdateHitRectInsets()
    RefreshLandmarks()
end

function TabOnEnter()
    BattlefieldMinimapTabText:Show()
    BattlefieldMinimapTabText:SetAlpha(1)
end

__Thread__()
function TabOnLeave()
    local st = GetTime()

    while not BattlefieldMinimapScroll:IsMouseOver() and not BattlefieldMinimapTab:IsMouseOver() do
        local opacity = (GetTime() - st) / 3.0

        if opacity < 1 then
            BattlefieldMinimapTabText:SetAlpha(1 - opacity)
        else
            BattlefieldMinimapTabText:Hide()
        end

        Next()
    end
end

function WorldMapOnShow(self)
    WorldMapTooltip:SetParent(WorldMapFrame)
    WorldMapTooltip:SetFrameLevel(1000)
end

function WorldMapOnHide(self)
    WorldMapTooltip:SetParent(UIParent)
    WorldMapTooltip:SetFrameLevel(1000)
end

function BattlefieldMinimapUnitPositionFrame_AddUnit(self, unit, path, width, height, ...)
    local scale = BattlefieldMinimap:GetScale()
    return ORIGIN_SETUNIT(self, unit, path, ORIGIN_PLAYER_SIZE / scale, ORIGIN_PLAYER_SIZE / scale, ...)
end

function UpdateOpacity(opacity)
    local alpha = 1 - opacity
    local numDetailTiles = GetNumberOfDetailTiles()
    for i=1, numDetailTiles do
        _G["BattlefieldMinimap"..i]:SetAlpha(alpha)
    end
    if ( alpha >= 0.15 ) then
        alpha = alpha - 0.15
    end
    for i=1, BattlefieldMinimap:GetAttribute("NUM_BATTLEFIELDMAP_OVERLAYS") do
        _G["BattlefieldMinimapOverlay"..i]:SetAlpha(alpha)
    end
end

function UpdateHitRectInsets()
    local x, y = BattlefieldMinimapScroll:GetHorizontalScroll(), BattlefieldMinimapScroll:GetVerticalScroll()
    local scale = BattlefieldMinimap:GetScale()
    local w, h = BattlefieldMinimap:GetSize()
    local mw, mh = BattlefieldMinimapScroll:GetSize()

    BattlefieldMinimap:SetHitRectInsets(x, w - x - mw / scale, y, h - y - mh / scale )
end

__Thread__()
function LockOnPlayer()
    while _SVDB.LockOnPlayer and not BattlefieldMinimapScroll:IsMouseOver() and BattlefieldMinimapScroll:IsVisible() do
        local x, y = GetPlayerMapPosition("player")

        if x > 0 or y > 0 then
            local scale  = BattlefieldMinimap:GetScale()
            local rx, ry = max(BattlefieldMinimap:GetWidth() - BattlefieldMinimapScroll:GetWidth() / scale, 0), max(BattlefieldMinimap:GetHeight() - BattlefieldMinimapScroll:GetHeight() / scale, 0)

            x = BattlefieldMinimap:GetWidth() * x - BattlefieldMinimapScroll:GetWidth() / 2 / scale
            y = BattlefieldMinimap:GetHeight() * y - BattlefieldMinimapScroll:GetHeight() / 2 / scale

            x = max(0, min(x, rx))
            y = max(0, min(y, ry))

            local cx, cy = BattlefieldMinimapScroll:GetHorizontalScroll(), BattlefieldMinimapScroll:GetVerticalScroll()

            if abs(cx - x) > 2 then if cx > x then x = cx - 2 else x = cx + 2 end end
            if abs(cy - y) > 2 then if cy > y then y = cy - 2 else y = cy + 2 end end

            BattlefieldMinimapScroll:SetHorizontalScroll(x)
            BattlefieldMinimapScroll:SetVerticalScroll(y)

            UpdateHitRectInsets()
        end

        Next()
    end
end

__Thread__()
function DrawQuestBlobs()
    BattlefieldMinimapBlob:DrawNone()

    Next()

    local questID = QuestMapFrame_GetDetailQuestID() or GetSuperTrackedQuestID()
    if not IsQuestComplete(questID) then
        BattlefieldMinimapBlob:DrawBlob(questID, true)
    end
end

__Thread__()
function DrawLandmarks()
    Next()

    if not _SVDB.ShowLandmark then return end

    local numPOIs           = GetNumMapLandmarks()
    local numGraveyards     = 0
    local currentGraveyard  = GetCemeteryPreference()
    local mapID             = GetCurrentMapAreaID()

    for i = 1, max(#POIArray, numPOIs) do
        local poi = GetPOIButton(i)
        if i <= numPOIs then
            local landmarkType, name, description, textureIndex, x, y, mapLinkID, inBattleMap, graveyardID, areaID, poiID, isObjectIcon, atlasIcon = GetMapLandmarkInfo(i)
            if( not WorldMap_ShouldShowLandmark(landmarkType) or (mapID ~= WORLDMAP_WINTERGRASP_ID and areaID == WORLDMAP_WINTERGRASP_POI_AREAID) ) then
                poi:Hide()
            else
                WorldMapPOIFrame_AnchorPOI(poi, x, y, WorldMap_GetFrameLevelForLandmark(landmarkType))
                if ( landmarkType == LE_MAP_LANDMARK_TYPE_NORMAL and WorldMap_IsSpecialPOI(poiID) ) then    --We have special handling for Isle of the Thunder King
                    WorldMap_HandleSpecialPOI(poi, poiID)
                else
                    WorldMap_ResetPOI(poi, isObjectIcon, atlasIcon)

                    if (not atlasIcon) then
                        local x1, x2, y1, y2
                        if (isObjectIcon) then
                            x1, x2, y1, y2 = GetObjectIconTextureCoords(textureIndex)
                        else
                            x1, x2, y1, y2 = GetPOITextureCoords(textureIndex)
                        end
                        poi.Texture:SetTexCoord(x1, x2, y1, y2)
                        poi.HighlightTexture:SetTexCoord(x1, x2, y1, y2)
                    else
                        poi.Texture:SetTexCoord(0, 1, 0, 1)
                        poi.HighlightTexture:SetTexCoord(0, 1, 0, 1)
                    end

                    poi.name = name
                    poi.description = description
                    poi.mapLinkID = mapLinkID
                    poi.poiID = poiID
                    poi.landmarkType = landmarkType
                    if ( graveyardID and graveyardID > 0 ) then
                        poi.graveyard = graveyardID
                        numGraveyards = numGraveyards + 1
                        local graveyard = GetGraveyardButton(numGraveyards)
                        graveyard:SetPoint("CENTER", poi)
                        graveyard:SetFrameLevel(poi:GetFrameLevel() - 1)
                        graveyard:Show()
                        if ( currentGraveyard == graveyardID ) then
                            graveyard.texture:SetTexture("Interface\\WorldMap\\GravePicker-Selected")
                        else
                            graveyard.texture:SetTexture("Interface\\WorldMap\\GravePicker-Unselected")
                        end
                        poi:Hide()     -- lame way to force tooltip redraw
                    else
                        poi.graveyard = nil
                    end
                end
                poi:Show()
            end
        else
            poi:Hide()
        end
    end

    for i = numGraveyards + 1, #GraveyardArray do
        GraveyardArray[i]:Hide()
    end
end

__Thread__()
function DrawQuestBonusObjectives()
    Next()

    if not _SVDB.ShowWorldQuest then return end

    local mapAreaID     = GetCurrentMapAreaID()
    local taskInfo      = C_TaskQuest.GetQuestsForPlayerByMapID(mapAreaID)
    local numTaskPOIs   = taskInfo and #taskInfo or 0

    local hasWorldQuests= false
    local taskIconIndex = 1

    if ( numTaskPOIs > 0 ) then
        for i, info in ipairs(taskInfo) do
            if ( HaveQuestData(info.questId) ) then
                local taskPOI
                local isWorldQuest = QuestUtils_IsQuestWorldQuest(info.questId)
                if ( isWorldQuest ) then
                    taskPOI = TryCreatingWorldQuestPOI(info, taskIconIndex)
                else
                    taskPOI = TryCreatingBonusObjectivePOI(info, taskIconIndex)
                end

                if ( taskPOI ) then
                    WorldMapPOIFrame_AnchorPOI(taskPOI, info.x, info.y, isWorldQuest and WORLD_MAP_POI_FRAME_LEVEL_OFFSETS.WORLD_QUEST or WORLD_MAP_POI_FRAME_LEVEL_OFFSETS.BONUS_OBJECTIVE)
                    taskPOI.questID = info.questId
                    taskPOI.numObjectives = info.numObjectives
                    taskPOI:Show()

                    taskIconIndex = taskIconIndex + 1

                    if ( isWorldQuest ) then
                        hasWorldQuests = true
                    end
                end
            end
        end
    end

    -- Hide unused icons in the pool
    for i = taskIconIndex, #TaskPOIArray do
        TaskPOIArray[i]:Hide()
    end
end

function WorldMapPOIFrame_AnchorPOI(poiButton, posX, posY, frameLevelOffset)
    if ( posX and posY ) then
        posX = posX * BattlefieldMinimapPOI:GetWidth()
        posY = posY * BattlefieldMinimapPOI:GetHeight()
        poiButton:SetPoint("CENTER", BattlefieldMinimapPOI, "TOPLEFT", posX, -posY)
        poiButton:SetFrameLevel(poiButton:GetParent():GetFrameLevel() + frameLevelOffset)
    end
end

function GetPOIButton(index)
    local button = POIArray[index]

    while #POIArray < index do
        button = CreateFrame("Button", nil, BattlefieldMinimapPOI)
        button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
        button:SetScript("OnEnter", WorldMapPOI_OnEnter)
        button:SetScript("OnLeave", WorldMapPOI_OnLeave)
        button:SetScript("OnClick", WorldMapPOI_OnClick)

        button.UpdateTooltip = WorldMapPOI_OnEnter

        button.Texture = button:CreateTexture(nil, "BACKGROUND")
        button.HighlightTexture = button:CreateTexture(nil, "HIGHLIGHT")
        button.HighlightTexture:SetBlendMode("ADD")
        button.HighlightTexture:SetAlpha(.4)
        button.HighlightTexture:SetAllPoints(button.Texture)

        POIArray:Insert(button)

        WorldMap_ResetPOI(button)
    end

    return button
end

function GetGraveyardButton(index)
    local button = GraveyardArray[index]

    while #GraveyardArray < index do
        button = CreateFrame("Button", nil, BattlefieldMinimapPOI)
        button:SetWidth(32)
        button:SetHeight(32)
        button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
        button:SetScript("OnEnter", nil)
        button:SetScript("OnLeave", nil)
        button:SetScript("OnClick", nil)

        local texture = button:CreateTexture(nil, "ARTWORK")
        texture:SetWidth(48)
        texture:SetHeight(48)
        texture:SetPoint("CENTER", 0, 0)
        button.texture = texture

        GraveyardArray:Insert(button)
    end

    return button
end

function GetTaskPOI(index)
    local button = TaskPOIArray[index]

    while #TaskPOIArray < index do
        button = CreateFrame("Button", "TestButton" ..index, BattlefieldMinimapPOI)
        button:SetFlattensRenderLayers(true)
        button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
        button:SetScript("OnEnter", TaskPOI_OnEnter)
        button:SetScript("OnLeave", TaskPOI_OnLeave)
        button:SetScript("OnClick", TaskPOI_OnClick)

        button.UpdateTooltip = TaskPOI_OnEnter

        button.Texture = button:CreateTexture(nil, "BACKGROUND")

        button.Glow = button:CreateTexture(nil, "BACKGROUND", -2)
        button.Glow:SetSize(50, 50)
        button.Glow:SetPoint("CENTER")
        button.Glow:SetTexture("Interface/WorldMap/UI-QuestPoi-IconGlow.tga")
        button.Glow:SetBlendMode("ADD")

        button.SelectedGlow = button:CreateTexture(nil, "OVERLAY", 2)
        button.SelectedGlow:SetBlendMode("ADD")

        button.CriteriaMatchGlow = button:CreateTexture(nil, "BACKGROUND", -1)
        button.CriteriaMatchGlow:SetAlpha(.6)
        button.CriteriaMatchGlow:SetBlendMode("ADD")

        button.SpellTargetGlow = button:CreateTexture(nil, "OVERLAY", 1)
        button.SpellTargetGlow:SetAtlas("worldquest-questmarker-abilityhighlight", true)
        button.SpellTargetGlow:SetAlpha(.6)
        button.SpellTargetGlow:SetBlendMode("ADD")
        button.SpellTargetGlow:SetPoint("CENTER", 0, 0)

        button.Underlay = button:CreateTexture(nil, "BACKGROUND")
        button.Underlay:SetWidth(34)
        button.Underlay:SetHeight(34)
        button.Underlay:SetPoint("CENTER", 0, -1)

        button.TimeLowFrame = CreateFrame("Frame", nil, button)
        button.TimeLowFrame:SetSize(22, 22)
        button.TimeLowFrame:SetPoint("CENTER", -10, -10)
        button.TimeLowFrame.Texture = button.TimeLowFrame:CreateTexture(nil, "OVERLAY")
        button.TimeLowFrame.Texture:SetAllPoints(button.TimeLowFrame)
        button.TimeLowFrame.Texture:SetAtlas("worldquest-icon-clock")

        WorldMap_ResetPOI(button, true, false)

        TaskPOIArray:Insert(button)
    end

    return button
end

function TryCreatingWorldQuestPOI(info, taskIconIndex)
    if ( WorldMap_IsWorldQuestSuppressed(info.questId) or not WorldMap_DoesWorldQuestInfoPassFilters(info) ) then
        return nil
    end

    local tagID, tagName, worldQuestType, rarity, isElite, tradeskillLineIndex = GetQuestTagInfo(info.questId)

    local taskPOI = GetTaskPOI(taskIconIndex)
    local selected = info.questId == GetSuperTrackedQuestID()

    local isCriteria = WorldMapFrame.UIElementsFrame.BountyBoard:IsWorldQuestCriteriaForSelectedBounty(info.questId)
    local isSpellTarget = SpellCanTargetQuest() and IsQuestIDValidSpellTarget(info.questId)

    taskPOI.worldQuest = true
    taskPOI.Texture:SetDrawLayer("OVERLAY")

    WorldMap_SetupWorldQuestButton(taskPOI, worldQuestType, rarity, isElite, tradeskillLineIndex, info.inProgress, selected, isCriteria, isSpellTarget)

    C_TaskQuest.RequestPreloadRewardData(info.questId)

    return taskPOI
end

function TryCreatingBonusObjectivePOI(info, taskIconIndex)
    local taskPOI = GetTaskPOI(taskIconIndex)

    taskPOI:SetSize(24, 24)
    taskPOI:SetNormalTexture(nil)
    taskPOI:SetPushedTexture(nil)
    taskPOI:SetHighlightTexture(nil)
    taskPOI.Underlay:Hide()
    taskPOI.Texture:SetAtlas("QuestBonusObjective")
    taskPOI.Texture:SetSize(24, 24)
    taskPOI.Texture:SetDrawLayer("BACKGROUND")
    taskPOI.TimeLowFrame:Hide()
    taskPOI.CriteriaMatchGlow:Hide()
    taskPOI.SpellTargetGlow:Hide()
    taskPOI.Glow:Hide()
    taskPOI.SelectedGlow:Hide()
    taskPOI.worldQuest = false

    return taskPOI
end

function WorldMapPOIFrame_SelectPOI(questID)
    -- POIs can overlap each other, bring the selection to the top
    local poiButton = QuestPOI_FindButton(BattlefieldMinimapPOI, questID)
    if ( poiButton ) then
        QuestPOI_SelectButton(poiButton)
        poiButton:Raise()
    else
        QuestPOI_ClearSelection(BattlefieldMinimapPOI)
    end
    DrawQuestBlobs()
end

function WorldMapPOIButton_Init(self)
    self:SetScript("OnEnter", WorldMapPOIButton_OnEnter);
    self:SetScript("OnLeave", WorldMapPOIButton_OnLeave);
end

function WorldMapPOIButton_OnEnter(self)
    WorldMapQuestPOI_SetTooltip(self, GetQuestLogIndexByID(self.questID));

    local _, posX, posY = QuestPOIGetIconInfo(self.questID);
    for _, poiType in pairs(BattlefieldMinimapPOI.poiTable) do
        for _, poiButton in pairs(poiType) do
            if ( poiButton ~= self and poiButton.used ) then
                local _, otherPosX, otherPosY = QuestPOIGetIconInfo(poiButton.questID);

                if ((math.pow(posX - otherPosX, 2) + math.pow(posY - otherPosY, 2)) < BLOB_OVERLAP_DELTA) then
                    WorldMapQuestPOI_AppendTooltip(poiButton, GetQuestLogIndexByID(poiButton.questID));
                end
            end
        end
    end
end
